Index: /palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3866)
@@ -1683,39 +1702,39 @@
 !> 'modpoints'.
 !------------------------------------------------------------------------------!
-    SUBROUTINE stretched_z(z, dz, dz_max, dz_stretch_factor, dz_stretch_level, &
-                           dz_stretch_level_start, dz_stretch_level_end,       &
-                           dz_stretch_factor_array)
-
-       REAL(dp), DIMENSION(:), INTENT(INOUT) ::  z, dz, dz_stretch_factor_array
-       REAL(dp), DIMENSION(:), INTENT(INOUT) ::  dz_stretch_level_start, dz_stretch_level_end
-       REAL(dp), INTENT(IN) ::  dz_max, dz_stretch_factor, dz_stretch_level
-
-       INTEGER ::  number_stretch_level_start        !< number of user-specified start levels for stretching
-       INTEGER ::  number_stretch_level_end          !< number of user-specified end levels for stretching
-
-       REAL(dp), DIMENSION(:), ALLOCATABLE ::  min_dz_stretch_level_end
-       REAL(dp) ::  dz_level_end, dz_stretched
-
-       INTEGER ::  dz_stretch_level_end_index(9)      !< vertical grid level index until which the vertical grid spacing is stretched
-       INTEGER ::  dz_stretch_level_start_index(9)    !< vertical grid level index above which the vertical grid spacing is stretched
-       INTEGER ::  dz_stretch_level_index = 0
-       INTEGER ::  k, n, number_dz
+ SUBROUTINE stretched_z(z, dz, dz_max, dz_stretch_factor, dz_stretch_level, &
+                        dz_stretch_level_start, dz_stretch_level_end,       &
+                        dz_stretch_factor_array)
+
+    REAL(wp), DIMENSION(:), INTENT(INOUT) ::  z, dz, dz_stretch_factor_array
+    REAL(wp), DIMENSION(:), INTENT(INOUT) ::  dz_stretch_level_start, dz_stretch_level_end
+    REAL(wp), INTENT(IN) ::  dz_max, dz_stretch_factor, dz_stretch_level
+
+    INTEGER ::  number_stretch_level_start        !< number of user-specified start levels for stretching
+    INTEGER ::  number_stretch_level_end          !< number of user-specified end levels for stretching
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  min_dz_stretch_level_end
+    REAL(wp) ::  dz_level_end, dz_stretched
+
+    INTEGER ::  dz_stretch_level_end_index(9)      !< vertical grid level index until which the vertical grid spacing is stretched
+    INTEGER ::  dz_stretch_level_start_index(9)    !< vertical grid level index above which the vertical grid spacing is stretched
+    INTEGER ::  dz_stretch_level_index = 0
+    INTEGER ::  k, n, number_dz
 
 !
 !-- Compute height of u-levels from constant grid length and dz stretch factors
-       IF ( dz(1) == -1.0_dp )  THEN
-          message = 'missing dz'
-          CALL inifor_abort( 'stretched_z', message)
-       ELSEIF ( dz(1) <= 0.0_dp )  THEN
-          WRITE( message, * ) 'dz=', dz(1),' <= 0.0'
-          CALL inifor_abort( 'stretched_z', message)
-       ENDIF
+    IF ( dz(1) == -1.0_wp )  THEN
+       message = 'missing dz'
+       CALL inifor_abort( 'stretched_z', message)
+    ELSEIF ( dz(1) <= 0.0_wp )  THEN
+       WRITE( message, * ) 'dz=', dz(1),' <= 0.0'
+       CALL inifor_abort( 'stretched_z', message)
+    ENDIF
 
 !
 !-- Initialize dz_stretch_level_start with the value of dz_stretch_level
 !-- if it was set by the user
-       IF ( dz_stretch_level /= -9999999.9_dp ) THEN
-          dz_stretch_level_start(1) = dz_stretch_level
-       ENDIF
+    IF ( dz_stretch_level /= -9999999.9_wp )  THEN
+       dz_stretch_level_start(1) = dz_stretch_level
+    ENDIF
        
 !
@@ -1727,54 +1746,54 @@
 !-- is used (Attention: The user is not allowed to specify a dz value equal
 !-- to the default of dz_max = 999.0). 
-       number_dz = COUNT( dz /= -1.0_dp .AND. dz /= dz_max )
-       number_stretch_level_start = COUNT( dz_stretch_level_start /=           &
-                                           -9999999.9_dp )
-       number_stretch_level_end = COUNT( dz_stretch_level_end /=               &
-                                         9999999.9_dp )
+    number_dz = COUNT( dz /= -1.0_wp .AND. dz /= dz_max )
+    number_stretch_level_start = COUNT( dz_stretch_level_start /=           &
+                                        -9999999.9_wp )
+    number_stretch_level_end = COUNT( dz_stretch_level_end /=               &
+                                      9999999.9_wp )
 
 !
 !-- The number of specified end levels +1 has to be the same than the number 
 !-- of specified dz values
-       IF ( number_dz /= number_stretch_level_end + 1 ) THEN
-          WRITE( message, * ) 'The number of values for dz = ',                &
-                              number_dz, 'has to be the same than ',           &
-                              'the number of values for ',                     &
-                              'dz_stretch_level_end + 1 = ',                   &
-                              number_stretch_level_end+1
-          CALL inifor_abort( 'stretched_z', message)
-       ENDIF
+    IF ( number_dz /= number_stretch_level_end + 1 )  THEN
+       WRITE( message, * ) 'The number of values for dz = ',                &
+                           number_dz, 'has to be the same than ',           &
+                           'the number of values for ',                     &
+                           'dz_stretch_level_end + 1 = ',                   &
+                           number_stretch_level_end+1
+       CALL inifor_abort( 'stretched_z', message)
+    ENDIF
     
 !
-!--    The number of specified start levels has to be the same or one less than 
-!--    the number of specified dz values
-       IF ( number_dz /= number_stretch_level_start + 1 .AND.                  &
-            number_dz /= number_stretch_level_start ) THEN
-          WRITE( message, * ) 'The number of values for dz = ',         &
-                              number_dz, 'has to be the same or one ', &
-                              'more than& the number of values for ',  &
-                              'dz_stretch_level_start = ',             &
-                              number_stretch_level_start
-          CALL inifor_abort( 'stretched_z', message)
-       ENDIF
+!-- The number of specified start levels has to be the same or one less than 
+!-- the number of specified dz values
+    IF ( number_dz /= number_stretch_level_start + 1 .AND.                  &
+         number_dz /= number_stretch_level_start )  THEN
+       WRITE( message, * ) 'The number of values for dz = ',         &
+                           number_dz, 'has to be the same or one ', &
+                           'more than& the number of values for ',  &
+                           'dz_stretch_level_start = ',             &
+                           number_stretch_level_start
+       CALL inifor_abort( 'stretched_z', message)
+    ENDIF
     
-!--    The number of specified start levels has to be the same or one more than 
-!--    the number of specified end levels
-       IF ( number_stretch_level_start /= number_stretch_level_end + 1 .AND.   &
-            number_stretch_level_start /= number_stretch_level_end ) THEN
-          WRITE( message, * ) 'The number of values for ',              &
-                              'dz_stretch_level_start = ',              &
-                              dz_stretch_level_start, 'has to be the ',&
-                              'same or one more than& the number of ', &
-                              'values for dz_stretch_level_end = ',    &
-                              number_stretch_level_end
-          CALL inifor_abort( 'stretched_z', message)
-       ENDIF
+!-- The number of specified start levels has to be the same or one more than 
+!-- the number of specified end levels
+    IF ( number_stretch_level_start /= number_stretch_level_end + 1 .AND.   &
+         number_stretch_level_start /= number_stretch_level_end )  THEN
+       WRITE( message, * ) 'The number of values for ',              &
+                           'dz_stretch_level_start = ',              &
+                           dz_stretch_level_start, 'has to be the ',&
+                           'same or one more than& the number of ', &
+                           'values for dz_stretch_level_end = ',    &
+                           number_stretch_level_end
+       CALL inifor_abort( 'stretched_z', message)
+    ENDIF
 
 !
 !-- Initialize dz for the free atmosphere with the value of dz_max
-       IF ( dz(number_stretch_level_start+1) == -1.0_dp .AND.                     &
-            number_stretch_level_start /= 0 ) THEN 
-          dz(number_stretch_level_start+1) = dz_max
-       ENDIF
+    IF ( dz(number_stretch_level_start+1) == -1.0_wp .AND.                     &
+         number_stretch_level_start /= 0 )  THEN 
+       dz(number_stretch_level_start+1) = dz_max
+    ENDIF
        
 !
@@ -1782,133 +1801,133 @@
 !-- atmosphere is desired (dz_stretch_level_end was not specified for the 
 !-- free atmosphere)
-       IF ( number_stretch_level_start == number_stretch_level_end + 1 ) THEN 
-          dz_stretch_factor_array(number_stretch_level_start) =                   &
-          dz_stretch_factor
+    IF ( number_stretch_level_start == number_stretch_level_end + 1 )  THEN 
+       dz_stretch_factor_array(number_stretch_level_start) =                   &
+       dz_stretch_factor
+    ENDIF
+
+!-- Allocation of arrays for stretching
+    ALLOCATE( min_dz_stretch_level_end(number_stretch_level_start) )
+
+!
+!-- The stretching region has to be large enough to allow for a smooth
+!-- transition between two different grid spacings
+    DO  n = 1, number_stretch_level_start
+       min_dz_stretch_level_end(n) = dz_stretch_level_start(n) +            &
+                                     4 * MAX( dz(n),dz(n+1) )
+    ENDDO
+
+    IF ( ANY( min_dz_stretch_level_end(1:number_stretch_level_start) >      &
+              dz_stretch_level_end(1:number_stretch_level_start) ) )  THEN
+    !IF ( ANY( min_dz_stretch_level_end >      &
+    !          dz_stretch_level_end ) ) THEN
+          message = 'Each dz_stretch_level_end has to be larger '  // &
+                    'than its corresponding value for ' //            &
+                    'dz_stretch_level_start + 4*MAX(dz(n),dz(n+1)) '//&
+                    'to allow for smooth grid stretching'
+          CALL inifor_abort('stretched_z', message)
+    ENDIF
+    
+!
+!-- Stretching must not be applied within the prandtl_layer 
+!-- (first two grid points). For the default case dz_stretch_level_start 
+!-- is negative. Therefore the absolut value is checked here.
+    IF ( ANY( ABS( dz_stretch_level_start ) < dz(1) * 1.5_wp ) )  THEN
+       WRITE( message, * ) 'Eeach dz_stretch_level_start has to be ',&
+                           'larger than ', dz(1) * 1.5
+          CALL inifor_abort( 'stretched_z', message)
+    ENDIF
+
+!
+!-- The stretching has to start and end on a grid level. Therefore 
+!-- user-specified values have to ''interpolate'' to the next lowest level
+    IF ( number_stretch_level_start /= 0 )  THEN
+       dz_stretch_level_start(1) = INT( (dz_stretch_level_start(1) -        &
+                                         dz(1)/2.0) / dz(1) )               &
+                                   * dz(1) + dz(1)/2.0
+    ENDIF
+    
+    IF ( number_stretch_level_start > 1 )  THEN
+       DO  n = 2, number_stretch_level_start
+          dz_stretch_level_start(n) = INT( dz_stretch_level_start(n) /      &
+                                           dz(n) ) * dz(n)
+       ENDDO
+    ENDIF
+    
+    IF ( number_stretch_level_end /= 0 )  THEN
+       DO  n = 1, number_stretch_level_end
+          dz_stretch_level_end(n) = INT( dz_stretch_level_end(n) /          &
+                                         dz(n+1) ) * dz(n+1)
+       ENDDO
+    ENDIF
+ 
+!
+!-- Determine stretching factor if necessary
+    IF ( number_stretch_level_end >= 1 )  THEN 
+       CALL calculate_stretching_factor( number_stretch_level_end, dz,      & 
+                                         dz_stretch_factor_array,           &   
+                                         dz_stretch_level_end,              &
+                                         dz_stretch_level_start )
+    ENDIF
+
+    z(1) = dz(1) * 0.5_wp
+!
+    dz_stretch_level_index = n
+    dz_stretched = dz(1)
+    DO  k = 2, n
+
+       IF ( dz_stretch_level <= z(k-1)  .AND.  dz_stretched < dz_max )  THEN
+
+          dz_stretched = dz_stretched * dz_stretch_factor
+          dz_stretched = MIN( dz_stretched, dz_max )
+
+          IF ( dz_stretch_level_index == n )  dz_stretch_level_index = k-1
+
        ENDIF
 
-!-- Allocation of arrays for stretching
-       ALLOCATE( min_dz_stretch_level_end(number_stretch_level_start) )
-
-!
-!--    The stretching region has to be large enough to allow for a smooth
-!--    transition between two different grid spacings
-       DO n = 1, number_stretch_level_start
-          min_dz_stretch_level_end(n) = dz_stretch_level_start(n) +            &
-                                        4 * MAX( dz(n),dz(n+1) )
-       ENDDO
-
-       IF ( ANY( min_dz_stretch_level_end(1:number_stretch_level_start) >      &
-                 dz_stretch_level_end(1:number_stretch_level_start) ) ) THEN
-       !IF ( ANY( min_dz_stretch_level_end >      &
-       !          dz_stretch_level_end ) ) THEN
-             message = 'Each dz_stretch_level_end has to be larger '  // &
-                       'than its corresponding value for ' //            &
-                       'dz_stretch_level_start + 4*MAX(dz(n),dz(n+1)) '//&
-                       'to allow for smooth grid stretching'
-             CALL inifor_abort('stretched_z', message)
-       ENDIF
-       
-!
-!--    Stretching must not be applied within the prandtl_layer 
-!--    (first two grid points). For the default case dz_stretch_level_start 
-!--    is negative. Therefore the absolut value is checked here.
-       IF ( ANY( ABS( dz_stretch_level_start ) < dz(1) * 1.5_dp ) ) THEN
-          WRITE( message, * ) 'Eeach dz_stretch_level_start has to be ',&
-                              'larger than ', dz(1) * 1.5
-             CALL inifor_abort( 'stretched_z', message)
-       ENDIF
-
-!
-!--    The stretching has to start and end on a grid level. Therefore 
-!--    user-specified values have to ''interpolate'' to the next lowest level
-       IF ( number_stretch_level_start /= 0 ) THEN
-          dz_stretch_level_start(1) = INT( (dz_stretch_level_start(1) -        &
-                                            dz(1)/2.0) / dz(1) )               &
-                                      * dz(1) + dz(1)/2.0
-       ENDIF
-       
-       IF ( number_stretch_level_start > 1 ) THEN
-          DO n = 2, number_stretch_level_start
-             dz_stretch_level_start(n) = INT( dz_stretch_level_start(n) /      &
-                                              dz(n) ) * dz(n)
-          ENDDO
-       ENDIF
-       
-       IF ( number_stretch_level_end /= 0 ) THEN
-          DO n = 1, number_stretch_level_end
-             dz_stretch_level_end(n) = INT( dz_stretch_level_end(n) /          &
-                                            dz(n+1) ) * dz(n+1)
-          ENDDO
-       ENDIF
- 
-!
-!--    Determine stretching factor if necessary
-       IF ( number_stretch_level_end >= 1 ) THEN 
-          CALL calculate_stretching_factor( number_stretch_level_end, dz,      & 
-                                            dz_stretch_factor_array,           &   
-                                            dz_stretch_level_end,              &
-                                            dz_stretch_level_start )
-       ENDIF
-
-       z(1) = dz(1) * 0.5_dp
-!
-       dz_stretch_level_index = n
-       dz_stretched = dz(1)
-       DO  k = 2, n
-
-          IF ( dz_stretch_level <= z(k-1)  .AND.  dz_stretched < dz_max )  THEN
-
-             dz_stretched = dz_stretched * dz_stretch_factor
-             dz_stretched = MIN( dz_stretched, dz_max )
-
-             IF ( dz_stretch_level_index == n ) dz_stretch_level_index = k-1
-
-          ENDIF
-
-          z(k) = z(k-1) + dz_stretched
-
-       ENDDO
-!--    Determine u and v height levels considering the possibility of grid
-!--    stretching in several heights.
-       n = 1
-       dz_stretch_level_start_index(:) = UBOUND(z, 1)
-       dz_stretch_level_end_index(:) = UBOUND(z, 1)
-       dz_stretched = dz(1)
-
-!--    The default value of dz_stretch_level_start is negative, thus the first
-!--    condition is always true. Hence, the second condition is necessary.
-       DO  k = 2, UBOUND(z, 1)
-          IF ( dz_stretch_level_start(n) <= z(k-1) .AND.                      &
-               dz_stretch_level_start(n) /= -9999999.9_dp ) THEN
-             dz_stretched = dz_stretched * dz_stretch_factor_array(n)
-             
-             IF ( dz(n) > dz(n+1) ) THEN
-                dz_stretched = MAX( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (higher) dz
-             ELSE
-                dz_stretched = MIN( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (lower) dz
-             ENDIF
-             
-             IF ( dz_stretch_level_start_index(n) == UBOUND(z, 1) )            &
-             dz_stretch_level_start_index(n) = k-1
-             
+       z(k) = z(k-1) + dz_stretched
+
+    ENDDO
+!-- Determine u and v height levels considering the possibility of grid
+!-- stretching in several heights.
+    n = 1
+    dz_stretch_level_start_index(:) = UBOUND(z, 1)
+    dz_stretch_level_end_index(:) = UBOUND(z, 1)
+    dz_stretched = dz(1)
+
+!-- The default value of dz_stretch_level_start is negative, thus the first
+!-- condition is always true. Hence, the second condition is necessary.
+    DO  k = 2, UBOUND(z, 1)
+       IF ( dz_stretch_level_start(n) <= z(k-1) .AND.                      &
+            dz_stretch_level_start(n) /= -9999999.9_wp )  THEN
+          dz_stretched = dz_stretched * dz_stretch_factor_array(n)
+          
+          IF ( dz(n) > dz(n+1) )  THEN
+             dz_stretched = MAX( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (higher) dz
+          ELSE
+             dz_stretched = MIN( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (lower) dz
           ENDIF
           
-          z(k) = z(k-1) + dz_stretched
+          IF ( dz_stretch_level_start_index(n) == UBOUND(z, 1) )            &
+          dz_stretch_level_start_index(n) = k-1
           
-!
-!--       Make sure that the stretching ends exactly at dz_stretch_level_end 
-          dz_level_end = ABS( z(k) - dz_stretch_level_end(n) ) 
-          
-          IF ( dz_level_end < dz(n+1)/3.0 ) THEN
-             z(k) = dz_stretch_level_end(n)
-             dz_stretched = dz(n+1)
-             dz_stretch_level_end_index(n) = k
-             n = n + 1             
-          ENDIF
-       ENDDO
-
-       DEALLOCATE( min_dz_stretch_level_end )
-
-    END SUBROUTINE stretched_z
+       ENDIF
+       
+       z(k) = z(k-1) + dz_stretched
+       
+!
+!--    Make sure that the stretching ends exactly at dz_stretch_level_end 
+       dz_level_end = ABS( z(k) - dz_stretch_level_end(n) ) 
+       
+       IF ( dz_level_end < dz(n+1)/3.0 )  THEN
+          z(k) = dz_stretch_level_end(n)
+          dz_stretched = dz(n+1)
+          dz_stretch_level_end_index(n) = k
+          n = n + 1             
+       ENDIF
+    ENDDO
+
+    DEALLOCATE( min_dz_stretch_level_end )
+
+ END SUBROUTINE stretched_z
 
 
@@ -1928,7 +1947,7 @@
                                          dz_stretch_level_start )
  
-    REAL(dp), DIMENSION(:), INTENT(IN)    ::  dz
-    REAL(dp), DIMENSION(:), INTENT(INOUT) ::  dz_stretch_factor_array
-    REAL(dp), DIMENSION(:), INTENT(IN)    ::  dz_stretch_level_end, dz_stretch_level_start
+    REAL(wp), DIMENSION(:), INTENT(IN)    ::  dz
+    REAL(wp), DIMENSION(:), INTENT(INOUT) ::  dz_stretch_factor_array
+    REAL(wp), DIMENSION(:), INTENT(IN)    ::  dz_stretch_level_end, dz_stretch_level_start
   
     INTEGER ::  iterations  !< number of iterations until stretch_factor_lower/upper_limit is reached  
@@ -1938,19 +1957,19 @@
     INTEGER, INTENT(IN) ::  number_end !< number of user-specified end levels for stretching
         
-    REAL(dp) ::  delta_l               !< absolute difference between l and l_rounded
-    REAL(dp) ::  delta_stretch_factor  !< absolute difference between stretch_factor_1 and stretch_factor_2
-    REAL(dp) ::  delta_total_new       !< sum of delta_l and delta_stretch_factor for the next iteration (should be as small as possible) 
-    REAL(dp) ::  delta_total_old       !< sum of delta_l and delta_stretch_factor for the last iteration 
-    REAL(dp) ::  distance              !< distance between dz_stretch_level_start and dz_stretch_level_end (stretching region)
-    REAL(dp) ::  l                     !< value that fulfil Eq. (5) in the paper mentioned above together with stretch_factor_1 exactly
-    REAL(dp) ::  numerator             !< numerator of the quotient
-    REAL(dp) ::  stretch_factor_1      !< stretching factor that fulfil Eq. (5) togehter with l exactly
-    REAL(dp) ::  stretch_factor_2      !< stretching factor that fulfil Eq. (6) togehter with l_rounded exactly
+    REAL(wp) ::  delta_l               !< absolute difference between l and l_rounded
+    REAL(wp) ::  delta_stretch_factor  !< absolute difference between stretch_factor_1 and stretch_factor_2
+    REAL(wp) ::  delta_total_new       !< sum of delta_l and delta_stretch_factor for the next iteration (should be as small as possible) 
+    REAL(wp) ::  delta_total_old       !< sum of delta_l and delta_stretch_factor for the last iteration 
+    REAL(wp) ::  distance              !< distance between dz_stretch_level_start and dz_stretch_level_end (stretching region)
+    REAL(wp) ::  l                     !< value that fulfil Eq. (5) in the paper mentioned above together with stretch_factor_1 exactly
+    REAL(wp) ::  numerator             !< numerator of the quotient
+    REAL(wp) ::  stretch_factor_1      !< stretching factor that fulfil Eq. (5) togehter with l exactly
+    REAL(wp) ::  stretch_factor_2      !< stretching factor that fulfil Eq. (6) togehter with l_rounded exactly
     
-    REAL(dp) ::  dz_stretch_factor_array_2(9) = 1.08_dp  !< Array that contains all stretch_factor_2 that belongs to stretch_factor_1 
+    REAL(wp) ::  dz_stretch_factor_array_2(9) = 1.08_wp  !< Array that contains all stretch_factor_2 that belongs to stretch_factor_1 
     
-    REAL(dp), PARAMETER ::  stretch_factor_interval = 1.0E-06  !< interval for sampling possible stretching factors
-    REAL(dp), PARAMETER ::  stretch_factor_lower_limit = 0.88  !< lowest possible stretching factor
-    REAL(dp), PARAMETER ::  stretch_factor_upper_limit = 1.12  !< highest possible stretching factor
+    REAL(wp), PARAMETER ::  stretch_factor_interval = 1.0E-06  !< interval for sampling possible stretching factors
+    REAL(wp), PARAMETER ::  stretch_factor_lower_limit = 0.88  !< lowest possible stretching factor
+    REAL(wp), PARAMETER ::  stretch_factor_upper_limit = 1.12  !< highest possible stretching factor
  
  
@@ -1963,6 +1982,6 @@
        delta_total_old = 1.0
        
-       IF ( dz(n) > dz(n+1) ) THEN
-          DO WHILE ( stretch_factor_1 >= stretch_factor_lower_limit ) 
+       IF ( dz(n) > dz(n+1) )  THEN
+          DO  WHILE ( stretch_factor_1 >= stretch_factor_lower_limit ) 
              
              stretch_factor_1 = 1.0 - iterations * stretch_factor_interval
@@ -1972,5 +1991,5 @@
                          stretch_factor_1 - distance/dz(n)
              
-             IF ( numerator > 0.0 ) THEN
+             IF ( numerator > 0.0 )  THEN
                 l = LOG( numerator ) / LOG( stretch_factor_1 ) - 1.0
                 l_rounded = NINT( l )
@@ -1991,5 +2010,5 @@
 !--                stretch_factor_2 would guarantee that the stretched dz(n) is
 !--                equal to dz(n+1) after l_rounded grid levels.
-             IF (delta_total_new < delta_total_old) THEN
+             IF (delta_total_new < delta_total_old)  THEN
                 dz_stretch_factor_array(n) = stretch_factor_1
                 dz_stretch_factor_array_2(n) = stretch_factor_2
@@ -2001,6 +2020,6 @@
           ENDDO
              
-       ELSEIF ( dz(n) < dz(n+1) ) THEN 
-          DO WHILE ( stretch_factor_1 <= stretch_factor_upper_limit )
+       ELSEIF ( dz(n) < dz(n+1) )  THEN 
+          DO  WHILE ( stretch_factor_1 <= stretch_factor_upper_limit )
                      
              stretch_factor_1 = 1.0 + iterations * stretch_factor_interval
@@ -2027,5 +2046,5 @@
 !--          stretch_factor_2 would guarantee that the stretched dz(n) is
 !--          equal to dz(n+1) after l_rounded grid levels.
-             IF (delta_total_new < delta_total_old) THEN
+             IF (delta_total_new < delta_total_old)  THEN
                 dz_stretch_factor_array(n) = stretch_factor_1
                 dz_stretch_factor_array_2(n) = stretch_factor_2
@@ -2045,6 +2064,6 @@
 !--    interval. If not, print a warning for the user.
        IF ( dz_stretch_factor_array_2(n) < stretch_factor_lower_limit .OR.     & 
-            dz_stretch_factor_array_2(n) > stretch_factor_upper_limit ) THEN
-          WRITE( message, * ) 'stretch_factor_2 = ',                    &
+            dz_stretch_factor_array_2(n) > stretch_factor_upper_limit )  THEN
+          WRITE( message, * ) 'stretch_factor_2 = ',                           &
                                      dz_stretch_factor_array_2(n), ' which is',&
                                      ' responsible for exactly reaching& dz =',&
@@ -2067,16 +2086,16 @@
 !> coordinate vector 'z' and stores it in 'zw'.
 !------------------------------------------------------------------------------!
-    SUBROUTINE midpoints(z, zw)
-
-        REAL(dp), INTENT(IN)  ::  z(0:)
-        REAL(dp), INTENT(OUT) ::  zw(1:)
-
-        INTEGER ::  k
-
-        DO k = 1, UBOUND(zw, 1)
-           zw(k) = 0.5_dp * (z(k-1) + z(k))
-        ENDDO
-
-    END SUBROUTINE midpoints
+ SUBROUTINE midpoints(z, zw)
+
+     REAL(wp), INTENT(IN)  ::  z(0:)
+     REAL(wp), INTENT(OUT) ::  zw(1:)
+
+     INTEGER ::  k
+
+     DO  k = 1, UBOUND(zw, 1)
+        zw(k) = 0.5_wp * (z(k-1) + z(k))
+     ENDDO
+
+ END SUBROUTINE midpoints
 
 !------------------------------------------------------------------------------!
